import { MutationFunction, MutationKey, QueryClient, UseMutationOptions } from "@tanstack/react-query";
import { MutationToolkit } from "./types/mutationToolkit";
export declare function createMutationToolkit(queryClient: QueryClient): <TMutationFnArgs, TMutationFnReturn, TContext>(mutationKey: MutationKey, mutationFn: MutationFunction<TMutationFnReturn, TMutationFnArgs>, defaultOptions?: UseMutationOptions<TMutationFnReturn, Error, TMutationFnArgs, TContext> | undefined) => MutationToolkit<TMutationFnArgs, TMutationFnReturn, unknown, TMutationFnReturn>;
