import { useIsFetching as K, defaultContext as I, useQuery as F, useInfiniteQuery as T } from "@tanstack/react-query";
import { generateKey as D } from "./internal/index.es.js";
import { returnByCondition as d } from "./internal/index.es2.js";
function E(u) {
  return (m, o, g = {}) => {
    const {
      passArgsToQueryKey: h = !0,
      queryType: k = "query",
      defaultOptions: y
    } = g, s = k === "infiniteQuery", Q = d(!s), f = d(s), w = D(m), c = (r, e) => w([
      ...r || [],
      ...h && e ? e : []
    ]), i = (r) => (e, n) => r(c(n == null ? void 0 : n.queryKey, e), o(...e || []), {
      context: I,
      ...y,
      ...n
    }), x = {
      useQuery: Q(i(F)),
      useInfiniteQuery: f(i(T)),
      useIsFetching: (r) => K(c(r == null ? void 0 : r.queryKey), r, {
        context: I
      })
    }, a = (r, e) => e(
      (n, t) => u[r](
        c(t == null ? void 0 : t.queryKey, n),
        o(...n || []),
        { ...y, ...t }
      )
    );
    return new Proxy(x, {
      get(r, e) {
        if (r[e])
          return r[e];
        switch (e) {
          case "fetchQuery":
          case "prefetchQuery":
            return a(e, Q);
          case "fetchInfiniteQuery":
          case "prefetchInfiniteQuery":
            return a(e, f);
          case "getQueryData":
          case "getQueryState":
          case "setQueryData":
            return (n, ...t) => u[e](c(n), ...t);
          default:
            if (!u[e])
              throw new Error("unknown property is given");
            return (...n) => u[e](...n);
        }
      }
    });
  };
}
export {
  E as createQueryToolkit
};
